=== debian/changelog ===
llvm-toolchain-7 (1:7.0.1-12) unstable; urgency=medium

  * debian/patches/947f9692440836dcb8d88b74b69dd379d85974ce.patch:
    - usptream fix for new glibc 2.31

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 23 Mar 2020 11:59:35 +0100

llvm-toolchain-7 (1:7.0.1-11) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Fix python lldb import, due to missing dependency on lldb-7 package

  [ Sandro Tosi ]
  * Drop -doc packages, in order to reduce rdeps of python-sphinx

 -- Sandro Tosi <morph@debian.org>  Mon, 23 Mar 2020 00:21:01 -0400

llvm-toolchain-7 (1:7.0.1-10) unstable; urgency=medium

  * Cherry-pick Ubuntu fixes from Matthias Klose:
  * (Build-)depend on python2 instead of python.
  * Fix the build to use python2 instead of python.
  * Call dh_python2 to rewrite shebangs.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 09 Jan 2020 18:08:37 +0100

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 11 Jan 2020 11:14:46 +0100

llvm-toolchain-7 (1:7.0.1-9) unstable; urgency=medium

  * Add ubuntu disco and eoan to supported ubuntu releases
  * Fixed wrong shlib generation of libomp5 library

  [ Andreas Beckmann ]
  * For now, lld doesn't generate shared libs. Removing the files
    (Closes: #857653, LP: #1829677)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 21 Apr 2019 22:55:47 +0200

llvm-toolchain-7 (1:7.0.1-8) unstable; urgency=medium

  * Fix a segfault in autopkgtest by brining
    pr39427-misscompile.diff back
    (Closes: #923456)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 28 Feb 2019 13:50:21 +0100

llvm-toolchain-7 (1:7.0.1-7) unstable; urgency=medium

  * Fix an ABI issue introduced with the kfreebsd support
    (Closes: #922731)
  * kfreebsd/kfreebsd-triple-clang.diff: update of the patch to fix
    the kfreebsd FTBFS  (Closes: #921246)
  * Enable ld gold for kfreebsd-amd64 and kfreebsd-i386
    Many thanks to Svante Signell for the three updates

  [ Matthias Klose ]
  * Remove the autopkg test for a genuine LLVM bug.

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 27 Feb 2019 10:07:00 +0100

llvm-toolchain-7 (1:7.0.1-6) unstable; urgency=medium

  * Add support for kfreebsd (Closes: #921246)
    Many thanks to Svante Signell for all patches

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 03 Feb 2019 17:27:51 +0100

llvm-toolchain-7 (1:7.0.1-5) unstable; urgency=medium

  * Add 'Rules-Requires-Root: no' in debian/control
  * llvm-7-examples: Force the same version of llvm-7-dev to mitigate
    a debci issue
    https://ci.debian.net/data/autopkgtest/unstable/amd64/l/llvm-toolchain-7/1635547/log.gz
  * Add 'Rules-Requires-Root: no' in debian/control
  * Because more and more tools in clang-tools are in python, add
    the dependency
  * Remove 'Multi-Arch: same' in libclang
    (Closes: #874248)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 04 Jan 2019 16:00:41 +0100

llvm-toolchain-7 (1:7.0.1-4) unstable; urgency=medium

  * Remove dbgsym packages from debci because of bug #917528

  [ Gianfranco Costamagna ]
  * Ignore a test result on i386, due to upstream bug 26580#c18

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 02 Jan 2019 12:37:45 +0100

llvm-toolchain-7 (1:7.0.1-3) unstable; urgency=medium

  * Also install clang-7-dbgsym libclang1-7-dbgsym in autopkgtest
    to verify that debug symbols are present
  * Cherry-pick upstream fix D52340 to address a rustc debuginfo
    (Closes: #917209)
  * Change the jit debug path from $HOME/.debug/jit/ to
    $TMPDIR/.debug/jit/ (Closes: #916393)
  * Document in README.source some Debian/Ubuntu specific changes

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 26 Dec 2018 22:57:45 +0100

llvm-toolchain-7 (1:7.0.1-2) unstable; urgency=medium

  * Enable -DENABLE_LINKER_BUILD_ID:BOOL=ON as, unlike gcc, isn't enabled
    by default in clang. Thanks to Adrian Bunk for the patch.
    Once more, thanks to Rebecca Palmer (Closes: #916975)
  * Build with -g1 also on 64bit architectures (thanks to Adrian too)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 21 Dec 2018 17:07:44 +0100

llvm-toolchain-7 (1:7.0.1-1) unstable; urgency=medium

  * New release
  * Remove the dbg workaround. Hopefully, the new version of
    binutils will fix it (Closes: #913946)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 16 Dec 2018 13:07:54 +0100

llvm-toolchain-7 (1:7.0.1~+rc3-2) unstable; urgency=medium

  * Fix llvm-config by stripping unnecessary flags
    See also https://bugs.llvm.org/show_bug.cgi?id=8220
    (Closes: #697755, #914838)
  * Try to workaround the debug issues by adding -fno-addrsig to the *FLAGS
    One more time, thanks to Rebecca Palmer (Closes: #913946)
    The goal is to provide correct debug packages.
    Workaround https://sourceware.org/bugzilla/show_bug.cgi?id=23788
  * Force the chmod +x on llvm-X/bin/* because it was sometimes removed
    by the strip process
  * Force the link to atomic also for i386 as it fails on Debian jessie too
  * Improved the debian/patches/series presentation by creating categories
  * Improve the separation between *FLAGS for gcc and clang.
    This is done for -fno-addrsig as it doesn't exit for gcc
    This can be done with the BOOTSTRAP_CMAKE_CXX_FLAGS option

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 10 Dec 2018 03:49:59 -0500

llvm-toolchain-7 (1:7.0.1~+rc3-1) unstable; urgency=medium

  * New testing release
  * disable the llvm-strip as it created too big llvm lib

  [ John Paul Adrian Glaubitz ]
  * Add patch to add powerpcspe support to clang
  * Add patch to fix register spilling on powerpcspe
  * Add patch to optimize double parameter calling setup on powerpcspe

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 08 Dec 2018 07:29:59 +0100

llvm-toolchain-7 (1:7.0.1~+rc2-8) unstable; urgency=medium

  * Use llvm-strip instead of binutils strip.
    Two reasons:
      - with clang stage2, the dbg packages were not generated
      - strip fails on stretch and other ubuntu on some archives

